.\" Copyright (c) 1994 Joerg Wunsch
.\"
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Joerg Wunsch
.\" 4. The name authors may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" @(#)mcon.1, 3.00, Last Edit-Date: [Mon Jan 10 21:28:22 1994]
.\"
.Dd January 3, 1994
.Dt MCON 1
.Sh NAME
.Nm mcon
.Nd controls pcvt mouse emulator
.Sh SYNOPSIS
.Nm mcon
.Op Fl l Ar left-button-key
.Op Fl m Ar mid-button-key
.Op Fl r Ar right-button-key
.Op Fl a Ar accel-time
.Op Fl s Ar 0 | false | \&no
.Op Fl s Ar 1 | true | yes
.Ar device
.Sh DESCRIPTION
The
.Nm mcon
utility controls the configurable parameters for the mouse emulator of
.Xr pcvt 4 .
.br
.Em NB :
The mouse emulator is not configured in by default; the system's config
file needs to specify an option line

.Em options Dq PCVT_EMU_MOUSE

in order to get its functionality.
.Pp
Either way, the
.Nm
program must be called with an argument
.Ar device
that specifies the device node used for the mouse emulation. This is
usually the first device node of the
.Xr pcvt 4
driver not being used as a virtual terminal device. E.\ g., if you
have configured eight virtual terminals
.Pq the default value ,
named
.Pa /dev/ttyv0
through
.Pa /dev/ttyv7 ,
the mouse emulator would allocate
.Pa /dev/ttyv8 .

If
.Nm
is called without any option, it will print the actual values of the
configurable parameters.

If called with an option, the program attempts to set up the new value.
.Pp
The options are as follows:
.Bl -tag -width Ds
.It Fl l Ar left-button-key
.It Fl m Ar mid-button-key
.It Fl r Ar right-button-key
Maps the named
.Ar button key
to emulate either the left, middle, or right mouse button.
.Ar Button key
is the usual name for that key. Normal ASCII keys are denoted by the
character they're labeled with, function keys are named
.Em f1
through
.Em f10 .
Note that the AT function keys
.Em f11
and
.Em f12
are
.Em extended
keys that cannot be mapped to be used with the mouse emulator since
it only allows basic PC-scancode keys to be used.

.It Fl a Ar accel-time
Set the time limit for the internal accelerator to
.Ar accel-time
milliseconds. Key events occurring after a longer time than this limit
will move the mouse cursor in single steps. Key events arriving more
frequently will move the cursor accelerated by a factor of 6. Note that
despite of
.Em milliseconds
being the unit of choice here, the time resolution is restricted by the
timer tick distance of the underlying operating system, usually to a
granularity of 10 milliseconds.

.It Fl s Ar 0 | false | \&no
.It Fl s Ar 1 | true | yes
The first form disables, the second form enables the
.Em sticky
behaviour of the mouse buttons. Sticky mouse keys behave much like
toggle-buttons: on first press, they become active, on second press,
they're deactivated. Pressing another button will deactivate any
other sticky button anyway.

Sticky buttons might be more convenient since you don't need 20 fingers
at all; on the other hand, they make it virtually impossible to initiate
double or triple mouse clicks.
.El
.Sh EXAMPLES
The following example would install the default behaviour of the
mouse emulator:

.Nm mcon
.Fl l Ar f1
.Fl m Ar f2
.Fl r Ar f3
.Fl a Ar 250
.Fl s Ar \&no
.Pa /dev/ttyv8
.Sh BUGS
The key names used to map the button-emulating keys to scan codes
.Pq and vica verse
are based on the American keyboard layout. This would usually not
cause any trouble since the
.Dq button-of-choice
is certainly some function key that should be equal for any national
keyboard layout.
.Pp
The mouse emulator is a rude hack at all; its only purpose is to provide
a device to move the pointer within an X-windowing environment.
.Sh SEE ALSO
.Xr X 1 ,
.Xr pcvt 4
.Sh HISTORY
The
.Nm
utility appeared in
.Xr pcvt 4 ,
release 3.00.
.Sh AUTHOR
The mouse emulator has been contributed by
.if n Joerg Wunsch.
.if t J\(:org Wunsch.
